/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* bos43D src/bos/kernel/sys/file.h 1.23                                  */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 1985,1990          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)93       1.23  src/bos/kernel/sys/file.h, syslfs, bos43D, 9747A_43D 11/21/97 10:35:43 */
#ifndef _H_FILE
#define _H_FILE

/*
 * COMPONENT_NAME: SYSLFS - Logical File System
 *
 * FUNCTIONS:
 *
 * ORIGINS: 27, 3, 26
 *
 * (C) COPYRIGHT International Business Machines Corp. 1985, 1990
 * All Rights Reserved
 * Licensed Materials - Property of IBM
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#include <sys/types.h>
#include <sys/param.h>
#include <sys/access.h>
#include <sys/lock_def.h>
#include <sys/cred.h>
#include <fcntl.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _KERNEL
/*
 * One file structure is allocated for each open/creat/pipe call.
 * Main use is to hold the read/write pointer associated with
 * each open file.
 */
struct	file {
	long	f_flag;		/* see fcntl.h for definitions */
	long	f_count;	/* reference count */
	short	f_options;	/* file flags not passed through vnode layer */
	short	f_type;		/* descriptor type */
	union {
		struct vnode	*f_uvnode;	/* pointer to vnode structure */
		struct file	*f_unext;	/* next entry in freelist */
	} f_up;
	offset_t f_offset;	/* read/write character pointer */
	off_t	f_dir_off;	/* BSD style directory offsets */
	struct ucred *f_cred;   /* process credentials at time of open */
	Simple_lock f_lock;	/* file structure fields lock */
	Simple_lock f_offset_lock; /* file structure offset field lock */
	caddr_t	f_vinfo;	/* any info vfs needs */ 
	struct fileops
	{
		int	(*fo_rw)();
		int	(*fo_ioctl)();
		int	(*fo_select)();
		int	(*fo_close)();
		int	(*fo_fstat)();
	} *f_ops;
};

#define	f_data		f_up.f_uvnode
#define	f_vnode		f_up.f_uvnode
#define	f_next		f_up.f_unext

/* f_type values */

#define	DTYPE_VNODE	1	/* file */
#define	DTYPE_SOCKET	2	/* communications endpoint */
#define	DTYPE_GNODE	3	/* device */
#define	DTYPE_OTHER    -1	/* unknown */

/* defines for f_options -- file flags that flags that don't need to be
 * passed through the vnode layer
 */
#define FAIO		0x0001		/* aio on this fp		*/
#define GCFMARK		0x0002		/* mark during unp_gc()		*/
#define GCFDEFER	0x0004		/* defer during unp_gc()	*/
#define FREVOKED	0x0008		/* file access has been revoked	*/
#define FAIO_FPATH	0x0010		/* Send down aio fast path	*/
#define FAIO_KPROC	0x0020		/* Send aio request to kproc	*/
#define FOBIT6		0x0040
#define FOBIT7		0x0080
#define FOBIT8		0x0100
#define FOBIT9		0x0200
#define FOBIT10		0x0400
#define FOBIT11		0x0800
#define FOBIT12		0x1000
#define FOBIT13		0x2000
#define FOBIT14		0x4000
#define FOBIT15		0x8000

extern struct file file[];	/* The file table itself */
extern struct file *ffreelist;	/* Head of freelist pool */
extern Simple_lock ffree_lock;	/* File Table Free List Lock */
#endif

/*
 * Flock call.
 */
#define	LOCK_SH		1	/* shared lock */
#define	LOCK_EX		2	/* exclusive lock */
#define	LOCK_NB		4	/* don't block when locking */
#define	LOCK_UN		8	/* unlock */

/*
 * Lseek call.
 */
#define	L_SET		0	/* absolute offset */
#define	L_INCR		1	/* relative to current offset */
#define	L_XTND		2	/* relative to end of file */

#ifdef __cplusplus
}
#endif

#endif /* _H_FILE */
